﻿;{ ==Code Header Comment==============================
;        Name/title: frmMain.pb
;   Executable name: NA Paet development of Report Designer Module
;           Version: 1.0
;            Author: Collectordave
;     Collaborators: Amílcar Matos Pérez
;    Translation by: 
;       Create date: 24\01\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.41 (x64),PureBasic 5.4LTS(X86)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Sets general report options and field display options
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

DeclareModule Options

  Global This_WindowID
  Global OkPressed.i,Cancel.i
  
  Declare Open()
  ;Declare Event_Handler(Event)
  
EndDeclareModule

Module Options

Global btnBack.i, btnNext.i,SelectedFolder.s,btnPageSetup.i,btnSelectQuery.i,btnSelectDatabase.i

Global strTitle.i,btnOk.i,btnCancel.i
Global strFolder.i
Global strDatabase.i
Global strPWidth.i,strPHeight.i,strPOrientation.i,strTopMargin.i,strLeftMargin.i,strBottomMargin.i,strRightMargin.i
Global strQuery.i,lstFields.i

;Global Page.i = 1
Global Dim Pages(2)

Global Pattern.s,MyDB.s

;Structure to haold gadget details for the field gadgets. Acts in a similar fashion to VB controls array.
Structure Controls
  FieldID.i
  FieldstrID.i
  IncludechkID.i
  TitlestrID.i
  PosstrID.i
  WidthstrID.i
EndStructure
  
Global Dim FieldCtrls.Controls(ArraySize(Report::FieldObject()))

Declare DisplayFieldControls()
Declare DisplayFieldData()

Procedure ParseQuery()
  
  Define Query.s,Length.i
  
  Query = QueryBuilder::Query
  Length = FindString(Query," FROM")
  Query = Left(Query,Length)
  Query = Right(Query,Len(Query)-7)

  For k = 1 To CountString(Query, ",") + 1
    ReDim Report::FieldObject(k)
    Report::FieldObject(k-1)\FieldName = Trim(StringField(Query, k, ","))
  Next

  ;Redim the FieldControls array ready for display
  ReDim FieldCtrls(ArraySize(Report::FieldObject()))
  DisplayFieldControls()
  DisplayFieldData()
  
EndProcedure

Procedure DisplayReportDetail()
  
  ;Procedure to display general report details
  
  SetGadgetText(strTitle,Report::Title)
  SetGadgetText(strDatabase,Report::DBName)  
  SetGadgetText(strQuery,Report::DBQuery)  
  SetGadgetText(StrPWidth,Str(Report::PageWidth))
  SetGadgetText(strPHeight,Str(Report::PageHeight))
  SetGadgetText(strTopMargin,Str(Report::TopMargin))
  SetGadgetText(strLeftMargin,Str(Report::LeftMargin) )         
  SetGadgetText(strBottomMargin,Str(Report::BottomMargin)  )           
  SetGadgetText(strRightMargin,Str(Report::RightMargin))
  
EndProcedure

Procedure DisplayFieldControls()
  
  ;Procedure to clear and then display controls to hold display field details
  
  FreeGadget(Pages(1)) ;Free the scrollarea gadget and all old field gadgets
  
  ;Create the new ScrollAreaGadget
  UseGadgetList(WindowID(This_WindowID))
  Pages(1) = ScrollAreaGadget(#PB_Any, 0, 0, 510, 180, 480, 450, 30)
    TextGadget(#PB_Any, 40, 10, 90, 20, "Field")
    TextGadget(#PB_Any, 220, 10, 90, 20, "Title")  
    TextGadget(#PB_Any, 320, 10, 70, 20, "Start")
    TextGadget(#PB_Any, 400, 10, 90, 20, "Width") 
  CloseGadgetList()
  
  HideGadget(Pages(1),#True) ;Hide the new scroll area gadget
  
  ;Create the new field gadgets
  OpenGadgetList(Pages(1))
  For iLoop = 0 To ArraySize(FieldCtrls()) - 1

      FieldCtrls(iLoop)\FieldID = TextGadget(#PB_Any, 10, (iLoop * 30) + 40, 90, 20, Str(iLoop + 1))
      FieldCtrls(iLoop)\FieldstrID = StringGadget(#PB_Any, 40, (iLoop * 30) + 35, 90, 20, "")  
      FieldCtrls(iLoop)\IncludechkID = CheckBoxGadget(#PB_Any, 140, (iLoop * 30) + 35, 70, 20, "Include", #PB_CheckBox_Right)
      FieldCtrls(iLoop)\TitlestrID = StringGadget(#PB_Any, 220, (iLoop * 30) +35, 90, 20, "")
      FieldCtrls(iLoop)\PosstrID = StringGadget(#PB_Any, 320, (iLoop * 30) +35, 40, 20, "")
      TextGadget(#PB_Any, 370, (iLoop * 30) + 40, 20, 20, "mm") 
      FieldCtrls(iLoop)\WidthstrID = StringGadget(#PB_Any, 400, (iLoop * 30) + 35, 40, 20, "")
      TextGadget(#PB_Any, 450, (iLoop * 30) + 40, 30, 20, "mm")
    Next iLoop
  CloseGadgetList()
  SetGadgetAttribute(Pages(1),#PB_ScrollArea_InnerHeight,(iLoop * 30) + 30)

EndProcedure

Procedure DisplayFieldData()
  
  ;Procedure to display actual field data
  
  For iLoop = 0 To ArraySize(FieldCtrls()) - 1
    
    If Report::FieldObject(iLoop)\Include = #True
      SetGadgetState(FieldCtrls(iLoop)\IncludechkID, #True)
    EndIf
        
    SetGadgetText(FieldCtrls(iLoop)\FieldstrID ,Report::FieldObject(iLoop)\FieldName)
    SetGadgetText(FieldCtrls(iLoop)\TitlestrID ,Report::FieldObject(iLoop)\Text) 
    SetGadgetText(FieldCtrls(iLoop)\PosstrID ,Str(Report::FieldObject(iLoop)\x))    
    SetGadgetText(FieldCtrls(iLoop)\WidthstrID ,Str(Report::FieldObject(iLoop)\Width))   
    
  Next iLoop
    
EndProcedure

Procedure.i SetReportProperties()
  
  If GetGadgetText(strTitle) > ""
    Report::Title  = GetGadgetText(strTitle)
  Else
    App::Message("More Information Required", "Report title must be entered",App::#OkOnly|App::#InformationIcon)     
    SetActiveGadget(strTitle)
    ProcedureReturn #False
  EndIf
  
  If GetGadgetText(strDatabase) > ""
    Report::DBName  = GetGadgetText(strDatabase)
  Else
    App::Message("More Information Required", "A database must be selected",App::#OkOnly|App::#InformationIcon)     
    SetActiveGadget(strDatabase)
    ProcedureReturn #False
  EndIf
  
  If GetGadgetText(strQuery) > ""
    Report::DBQuery  = GetGadgetText(strQuery)
  Else
    App::Message("More Information Required","A database query must be defined",App::#OkOnly|App::#InformationIcon)   
    SetActiveGadget(strQuery)
    ProcedureReturn #False
  EndIf
  
  If GetGadgetText(strPWidth) > ""
    Report::PageWidth  = Val(GetGadgetText(strPWidth))
  Else
    App::Message("More Information Required", "Page width must be defined!",App::#OkOnly|App::#InformationIcon)     
    SetActiveGadget(strPWidth)
    ProcedureReturn #False
  EndIf  
  
  If GetGadgetText(strPHeight) > ""
    Report::PageHeight  = Val(GetGadgetText(strPHeight))
  Else
    App::Message("More Information Required", "Page height must be defined!",App::#OkOnly|App::#InformationIcon)    
    SetActiveGadget(strPHeight)
    ProcedureReturn #False
  EndIf   
  
  ;Margins can be zero so no test
  Report::TopMargin = Val(GetGadgetText(strTopMargin))
  Report::LeftMargin = Val(GetGadgetText(strLeftMargin))           
  Report::BottomMargin = Val(GetGadgetText(strBottomMargin))             
  Report::RightMargin = Val(GetGadgetText(strRightMargin))  
  
  ;ToDo: Check that at least one field is selected for the report

  For k = 0 To ArraySize(FieldCtrls()) - 1
    
    Report::FieldObject(k)\FieldName = GetGadgetText(FieldCtrls(k)\FieldstrID)    
    If GetGadgetState(FieldCtrls(k)\IncludechkID) = #PB_Checkbox_Checked 
      Report::FieldObject(k)\Include = #True
    Else
      Report::FieldObject(k)\Include = #False    
    EndIf
    Report::FieldObject(k)\Text = GetGadgetText(FieldCtrls(k)\TitlestrID)
    Report::FieldObject(k)\x = Val(GetGadgetText(FieldCtrls(k)\PosstrID))  
    Report::FieldObject(k)\Width = Val(GetGadgetText(FieldCtrls(k)\WidthstrID))    

  Next k
  
  ProcedureReturn #True
  
EndProcedure

Procedure Open()
  
  This_WindowID = OpenWindow(#PB_Any, 0, 0, 510, 225, "Report Options", #PB_Window_Tool | #PB_Window_ScreenCentered)
  
  Pages(0) = ContainerGadget(#PB_Any, 0, 0, 510, 180, #PB_Container_Raised)
  
    TextGadget(#PB_Any, 20, 15, 50, 20, "Title", #PB_Text_Right)  
    strTitle = StringGadget(#PB_Any, 80, 10, 380, 20, Report::Title)
    TextGadget(#PB_Any, 10, 45, 60, 20, "Database", #PB_Text_Right)
    strDatabase = StringGadget(#PB_Any, 80, 40, 380, 20, Report::DBName)
    btnSelectDatabase = ButtonGadget(#PB_Any, 460, 40, 30, 20, "...")
    TextGadget(#PB_Any, 20, 75, 50, 20, "Query", #PB_Text_Right)
    strQuery = StringGadget(#PB_Any, 80, 70, 380, 20, "",#PB_String_ReadOnly)
    SetGadgetColor(strQuery, #PB_Gadget_BackColor,App::#ColWhite )
    btnSelectQuery = ButtonGadget(#PB_Any, 460, 70, 30, 20, "...") 
    TextGadget(#PB_Any, 20, 105, 50, 20, "Page", #PB_Text_Right)
    TextGadget(#PB_Any, 70, 105, 40, 20, "Width", #PB_Text_Right)
    TextGadget(#PB_Any, 20, 135, 50, 20, "Margins", #PB_Text_Right) 
    strPWidth = StringGadget(#PB_Any, 115, 100, 50, 20, "", #PB_String_ReadOnly)
    SetGadgetColor(strPWidth, #PB_Gadget_BackColor,App::#ColWhite)
    TextGadget(#PB_Any, 170, 105, 50, 20, "Height", #PB_Text_Right)
    strPHeight = StringGadget(#PB_Any, 225, 100, 40, 20, "", #PB_String_ReadOnly)
    SetGadgetColor(strPHeight, #PB_Gadget_BackColor,App::#ColWhite)
    TextGadget(#PB_Any, 280, 105, 60, 20, "Orientation", #PB_Text_Right)
    strPOrientation = StringGadget(#PB_Any, 350, 100, 70, 20, "", #PB_String_ReadOnly)
    SetGadgetColor(strPOrientation, #PB_Gadget_BackColor,App::#ColWhite ) 
    btnPageSetup = ButtonGadget(#PB_Any, 420, 100, 30, 20, "...")
    GadgetToolTip(btnPageSetup, "Set Page Options")
    TextGadget(#PB_Any, 70, 135, 30, 20, "Top", #PB_Text_Right)
    strTopMargin = StringGadget(#PB_Any, 105, 130, 30, 20, "", #PB_String_ReadOnly)
    SetGadgetColor(strTopMargin, #PB_Gadget_BackColor,App::#ColWhite)
    TextGadget(#PB_Any, 150, 135, 30, 20, "Left", #PB_Text_Right)
    strLeftMargin = StringGadget(#PB_Any,185, 130, 30, 20, "", #PB_String_ReadOnly)
    SetGadgetColor(strLeftMargin, #PB_Gadget_BackColor,App::#ColWhite)
    TextGadget(#PB_Any, 220, 135, 50, 20, "Bottom", #PB_Text_Right)
    strBottomMargin = StringGadget(#PB_Any, 275, 130, 30, 20, "", #PB_String_ReadOnly)
    SetGadgetColor(strBottomMargin, #PB_Gadget_BackColor,App::#ColWhite)
    TextGadget(#PB_Any,310, 135, 40, 20, "Right", #PB_Text_Right)
    strRightMargin = StringGadget(#PB_Any, 355, 130, 30, 20, "", #PB_String_ReadOnly)
    SetGadgetColor(strRightMargin, #PB_Gadget_BackColor,App::#ColWhite)

  CloseGadgetList()
    
  Pages(1) = ScrollAreaGadget(#PB_Any, 0, 0, 510, 180, 480, 450, 30)
    TextGadget(#PB_Any, 40, 10, 90, 20, "Field")
    TextGadget(#PB_Any, 220, 10, 90, 20, "Title")  
    TextGadget(#PB_Any, 320, 10, 70, 20, "Start")
    TextGadget(#PB_Any, 400, 10, 90, 20, "Width") 
  CloseGadgetList()

  
  btnBack = ButtonGadget(#PB_Any, 250, 190, 50, 25, "< Back")
  btnNext = ButtonGadget(#PB_Any, 310, 190, 50, 25, "Next >")
  btnOk = ButtonGadget(#PB_Any, 390, 190, 50, 25, "Ok")
  btnCancel = ButtonGadget(#PB_Any, 450, 190, 50, 25, "Cancel")  
  HideGadget(Pages(1),#True)
  
  DisplayReportDetail()
  ReDim FieldCtrls(ArraySize(Report::FieldObject()))
  DisplayFieldControls()
  DisplayFieldData()
  StickyWindow(This_WindowID,#True)
  
  ;This loop stalls main loop until options are set
  Repeat
    
    Event = WaitWindowEvent()
    
    Select EventWindow()
 
      Case QueryBuilder::Window_ID

        If IsWindow(QueryBuilder::Window_ID)
          QueryBuilder::Event_Handler(Event)
          If QueryBuilder::OkPressed = #True
            If QueryBuilder::Query > ""
              SetGadgetText(strQuery,QueryBuilder::Query)
              ParseQuery()
            EndIf
          EndIf
        EndIf    
     
      Default
      
        Select event
      
          Case #PB_Event_Gadget
            
            Select EventGadget()
            
              Case btnNext

                HideGadget(Pages(0),#True)
                HideGadget(Pages(1),#False)
          
              Case btnBack
            
                HideGadget(Pages(1),#True)
                HideGadget(Pages(0),#False)
          
        Case btnOk
          
          If SetReportProperties()

            OkPressed = #True
            ;Close Child windows
            CloseWindow(This_WindowID)
            Break
            This_WindowID = -1 
          Else
            Ok = #False
          EndIf
          
        Case btnCancel
          OkPressed = #False
          Cancel = #True
          ;Close Child windows
          CloseWindow(This_WindowID)
          Break
          This_WindowID = -1         
          
        Case btnSelectDatabase
          Pattern = "Database (*.db)|*.db;|All files (*.*)|*.*"
          MyDB = OpenFileRequester("Please choose Database", GetCurrentDirectory(), Pattern, 0)
          If MyDB
            SetGadgetText(strDatabase,MyDB)
            Report::DBName = MyDB
          Else
            SetGadgetText(strDatabase,"")
            Report::DBName = ""
          EndIf  
          
        Case btnSelectQuery
          
          If Not IsWindow(QueryBuilder::Window_ID)
            QueryBuilder::Open(Report::DBName)
          EndIf

        Case btnPageSetup
                    
          ;Pass Current Report Page Detail
          CDPrint::PageWidth = Report::PageWidth 
          CDPrint::PageHeight = Report::PageHeight
          CDPrint::TopMargin = Report::TopMargin
          CDPrint::LeftMargin = Report::LeftMargin            
          CDPrint::BottomMargin = Report::BottomMargin              
          CDPrint::RightMargin  = Report::RightMargin 
          CDPrint::Page_Setup()
          If CDPrint::OKPressed = #True
            Report::PageWidth = CDPrint::PageWidth
            Report::PageHeight = CDPrint::PageHeight
            Report::TopMargin = CDPrint::TopMargin
            Report::LeftMargin = CDPrint::LeftMargin            
            Report::BottomMargin = CDPrint::BottomMargin             
            Report::RightMargin = CDPrint::RightMargin
            DisplayReportDetail()
          EndIf
          
      EndSelect
      
  EndSelect
  
EndSelect

ForEver

EndProcedure

EndModule
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 372
; FirstLine = 225
; Folding = X9
; EnableUnicode
; EnableXP