﻿;{ ==Code Header Comment==============================
;        Name/title: frmMain.pb
;   Executable name: NA Paet development of Report Designer Module
;           Version: 1.0
;            Author: Collectordave
;     Collaborators: Amílcar Matos Pérez
;    Translation by: 
;       Create date: 24\01\2016
; Previous releases: 
; This Release Date: 
;  Operating system: Windows  [X]GUI
;  Compiler version: PureBasic 5.41 (x64),PureBasic 5.4LTS(X86)
;         Copyright: (C)2016
;           License: 
;         Libraries: 
;     English Forum: 
;      French Forum: 
;      German Forum: 
;  Tested platforms: Windows
;       Description: Main report designer form and control
; ====================================================
;.......10........20........30........40........50........60........70........80
;}

EnableExplicit

UseJPEGImageDecoder()
 
;{   Include Files Section
IncludeFile "App.pbi"
IncludeFile "CDPrint.pbi"             ;Printing Library
IncludeFile "Report.pbi"                ;Describes Report
IncludeFile "Simple Query Builder.pbi"  ;Allows user to create a report query
;IncludeFile "PageSetup.pbi"             ;Sets report page dimensions and margins
IncludeFile "SelectImages.pbi"          ;Select Image file
IncludeFile "Configtext.pbi"            ;Set Text Options on report
IncludeFile "ConfigImage.pbi"           ;Set image properties
IncludeFile "Options.pbi"               ;Set general options
;}


;{ Variable declarations

Global isCurrentItem.i,currentItemXOffset.i,currentItemYOffset.i,Drag.i

Global frmMain.i  ;Main Window ID

;Main window gadget IDs
Global ScrollArea_0.i     ;Scroll area holding report canvas gadgets
Global cvsReportHeader.i  ;Report header canvas gadget
Global cvsPageHeader.i    ;Section header canvas gadget
Global SectionHeaderFont.i;Font for section Header
Global cvsDetail.i        ;detail section canvas gadget
Global DetailSectionFont.i;Font for Detail Section
Global btnReportHeader.i  ;Report header button unused at present
Global btnPageHeader.i    ;Section header button unused at present
Global btnDetail.i        ;Detail section button unused at present
Global cvsRuler.i         ;Ruler line canvas gadget

            ;Pixels Per Millimeter
Global CanvasWidth.i      ;Width of canvas required in pixels
Global cvsOffset.i        ;Offset of canvas in scroll area if required

;Page detail display gadgets
Global txtPageDetail.i
Global strPageWidth.i
Global strPageHeight.i
Global strLeftMargin.i
Global strTopMargin.i
Global strBottomMargin.i
Global strRightMargin.i

;Gadget Operations
Global ActiveGadget.i = -1

;Constants for the mainwindow menu
Enumeration Menus
  #mnuReportNew
  #mnuReportLoad
  #mnuReportSave
  #mnuReportOptions
  #mnuReportPreview
  #mnuReportPrint
  #mnuExit
  #mnuHdrInsTxt
  #mnuHdrInsImg
  #mnuHdrDel
EndEnumeration

Global Adorner1.i,Adorner2.i,Adorner3.i,Adorner4.i
Global Trying.l,ActiveMove.i,ActivePopGadget.l,strTest.i
Global Headermnu.i,Gadx.i,Gady.i,Gadw.i,Gadh.i

;}

Define Event.i    ;Main event loop variable
Define iLoop.i

Macro GadgetHitTest(x, y,iLoop)
  ;Simple macro to simplify obtaining which object has been clicked
  (((Not x < Report::HeaderObject(iLoop)\x) & (Not y< Report::HeaderObject(iLoop)\y)) &(Not x>=(Report::HeaderObject(iLoop)\x+Report::HeaderObject(iLoop)\Width)) & (Not y>=(Report::HeaderObject(iLoop)\y+Report::HeaderObject(iLoop)\Height)))
EndMacro 

Procedure HeaderHitTest(x,y)
  
  Define Match.i

  If LastElement(report::NewHeaderObject()) ; search for hit, starting from end (z-order)
    Repeat

      If x >= Report::NewHeaderObject()\x And x <  report::NewHeaderObject()\x + report::NewHeaderObject()\width

        If y >= report::NewHeaderObject()\y And y < report::NewHeaderObject()\y + report::NewHeaderObject()\height

          match = #True
          Break
        EndIf
      EndIf
    Until PreviousElement(report::NewHeaderObject())=0
  EndIf
  If match
    isCurrentItem = #True
    currentItemXOffset = x - Report::NewHeaderObject()\x
    currentItemYOffset = y - Report::NewHeaderObject()\y
    report::Temp = Report::NewHeaderObject()
    DeleteElement(Report::NewHeaderObject())
    LastElement(Report::NewHeaderObject()) ; move match to last position (z-order)
    AddElement(Report::NewHeaderObject())
    report::NewHeaderObject() = Report::Temp
  Else
    isCurrentItem = #False
  EndIf
  ProcedureReturn isCurrentItem
    
EndProcedure

Procedure DrawHeader()
  
    StartDrawing(CanvasOutput(cvsReportHeader))
  
    ;Clear Canvas
    Box(0,0,GadgetWidth(cvsReportHeader),GadgetHeight(cvsReportHeader),App::#ColWhite)
    DrawingMode(#PB_2DDrawing_Transparent)  
    
    ;Draw The Objects
    ForEach Report::NewHeaderObject()
      
      Select report::NewHeaderObject()\Type
        
        Case "Text"

          DrawingFont(FontID(Report::NewHeaderObject()\ID)) 
          Report::NewHeaderObject()\Height = TextHeight(Report::NewHeaderObject()\Text)/App::PPmm
          Report::NewHeaderObject()\Width = TextWidth(Report::NewHeaderObject()\Text)/App::PPmm
          DrawText((Report::NewHeaderObject()\x * App::PPmm),(Report::NewHeaderObject()\y * App::PPmm) ,Report::NewHeaderObject()\Text,Report::NewHeaderObject()\Colour,App::#ColWhite)   
            
        Case "Image"

          DrawImage(ImageID(Report::NewHeaderObject()\ID),(Report::NewHeaderObject()\x * App::PPmm),(Report::NewHeaderObject()\y * App::PPmm),(Report::NewHeaderObject()\Width * App::PPmm),(Report::NewHeaderObject()\Height * App::PPmm))        
          
      EndSelect    ;NewHeaderObject()\Type  

    Next
    
    StopDrawing()
 
EndProcedure

Procedure FreeFieldObjects()
  
  Define iLoop.i
  
  OpenGadgetList(ScrollArea_0)
    
  ;Remove Field Objects
  For iLoop = 0 To ArraySize(Report::FieldObject()) -1

    If IsGadget(Report::FieldObject(iLoop)\FieldID)
      FreeGadget(Report::FieldObject(iLoop)\FieldID)
    EndIf
    If IsGadget(Report::FieldObject(iLoop)\TextID)
      FreeGadget(Report::FieldObject(iLoop)\TextID)
    EndIf   
    
  Next iLoop
  
  CloseGadgetList()
    
EndProcedure 

Procedure ShowReportDetail()
  
  ;Procedure to show the report page detail as set in Options\load\New
  SetWindowTitle(frmMain,"Report Designer:- " + Report::Title)  
  SetGadgetText(strPageWidth,Str(Report::PageWidth))
  SetGadgetText(strPageHeight,Str(Report::PageHeight))
  SetGadgetText(strTopMargin,Str(Report::TopMargin))
  SetGadgetText(strLeftMargin,Str(Report::LeftMargin))
  SetGadgetText(strBottomMargin,Str(Report::BottomMargin))
  SetGadgetText(strRightMargin,Str(Report::RightMargin))
  
EndProcedure

Procedure DrawRuler()
  
  ;Procedure to resize report canvas gadgets and display central in the scroll area
  
  Define DisplayHeight.i
  Define cvsDetailheight.i,cvsDetailTop.i,btnDetailTop.i
  Define cvsSectionHeight.i,cvsSectionTop.i,btnSectionTop.i
  Define cvsHeaderHeight.i 
  Define iLoop.i
  Define UsedWidth.i
  
  DisplayHeight  = GetGadgetAttribute(ScrollArea_0,#PB_ScrollArea_InnerHeight)
  
  ;Calculate height of detail canvas
  StartDrawing(WindowOutput(frmMain))
    DrawingFont(FontID(Report::FieldFontID)) 
    cvsDetailheight = TextHeight("HhGgPp") + 4
  StopDrawing()
  cvsDetailTop = DisplayHeight - cvsDetailheight
  btnDetailTop = cvsDetailTop - 20
  
  ;Calculate height and position of section canvas  
  StartDrawing(WindowOutput(frmMain))
    DrawingFont(FontID(Report::SectionHeaderFontID)) 
    cvsSectionHeight = TextHeight("HhGgPp") + 4
  StopDrawing()
  cvsSectionTop = btnDetailTop - cvsSectionHeight
  btnSectionTop = cvsSectionTop - 20
  
  ;Calculate height of header canvas  
  cvsHeaderHeight =  btnSectionTop - 40
  
  UsedWidth = Report::PageWidth - (Report::LeftMargin + Report::RightMargin)
  CanvasWidth = UsedWidth * App::PPmm

  If CanvasWidth < 780
    cvsOffset = (780 - CanvasWidth )/2
  Else
    cvsOffset = 0
  EndIf
  
  ;Resize all the canvas gadgets and buttons
  SetGadgetAttribute(ScrollArea_0,#PB_ScrollArea_InnerWidth,CanvasWidth + cvsOffset) 
  ResizeGadget(cvsRuler,cvsOffset,#PB_Ignore,CanvasWidth,#PB_Ignore)
  ResizeGadget(btnReportHeader,cvsOffset,#PB_Ignore,CanvasWidth,#PB_Ignore)
  ResizeGadget(cvsReportHeader,cvsOffset,#PB_Ignore,CanvasWidth,cvsHeaderHeight)
  ResizeGadget(btnPageHeader,cvsOffset,btnSectionTop,CanvasWidth,#PB_Ignore)
  ResizeGadget(cvsPageHeader,cvsOffset,cvsSectionTop,CanvasWidth,cvsSectionHeight)
  ResizeGadget(btnDetail,cvsOffset,btnDetailTop,CanvasWidth,#PB_Ignore)
  ResizeGadget(cvsDetail,cvsOffset,cvsDetailTop,CanvasWidth,cvsDetailheight)  
  
  ;Draw the ruler line
  If StartDrawing(CanvasOutput(cvsRuler))

    For iLoop = 1 To UsedWidth

      If  Mod(iLoop, 10) = 0
        LineXY(iLoop * App::PPmm, 0, iLoop * App::PPmm,20,RGB(100,100,100))
        DrawText((iLoop * App::PPmm) + 2,5,Str(iLoop/10),RGB(0,0,0),App::#ColWhite)
      ElseIf Mod(iLoop, 5) = 0
        LineXY(iLoop * App::PPmm, 0, iLoop * App::PPmm,10,RGB(100,100,100))
      Else
        LineXY(iLoop * App::PPmm, 0, iLoop * App::PPmm,5,RGB(100,100,100))
      EndIf
        
    Next iLoop
    
    StopDrawing()
      
  EndIf

EndProcedure

Procedure DrawFieldObjects()
  
  Define iLoop.i
  Define x.i,y.i,SecWidth.i,SecHeight.i,FldWidth.i,FldHeight.i
  Define objFont.i

  For iLoop = 0 To ArraySize(Report::FieldObject()) 
 
    If Report::FieldObject(iLoop)\Include = #True
      
      x = Report::FieldObject(iLoop)\x
      y = 0
      StartDrawing(WindowOutput(frmMain))
      DrawingFont(FontID(Report::FieldFontID)) 
      FldHeight = TextHeight(Report::FieldObject(iLoop)\FieldName) 
      FldWidth = TextWidth(Report::FieldObject(iLoop)\FieldName)
      DrawingFont(FontID(Report::SectionHeaderFontID)) 
      SecHeight = TextHeight(Report::FieldObject(iLoop)\FieldName) 
      SecWidth = TextWidth(Report::FieldObject(iLoop)\FieldName)     
      StopDrawing()
      FldWidth = Report::FieldObject(iLoop)\Width
      SecWidth = FldWidth
      
      OpenGadgetList(ScrollArea_0)
    
      ;Add new field and title objects
      Report::FieldObject(iLoop)\FieldID = TextGadget(#PB_Any, x, y, FldWidth, FldHeight, "")
      Report::FieldObject(iLoop)\TextID = TextGadget(#PB_Any, x, y, SecWidth, SecHeight, "")   
      CloseGadgetList()
      
      SetGadgetColor(Report::FieldObject(iLoop)\FieldID,#PB_Gadget_FrontColor,Report::FieldColour)
      SetGadgetColor(Report::FieldObject(iLoop)\FieldID,#PB_Gadget_BackColor ,App::#ColWhite)     
      SetGadgetFont(Report::FieldObject(iLoop)\FieldID, FontID(Report::FieldFontID))
      SetGadgetText(Report::FieldObject(iLoop)\FieldID, "[" + Report::FieldObject(iLoop)\FieldName + "]")
      ResizeGadget(Report::FieldObject(iLoop)\FieldID, (x* App::PPmm) + cvsOffset, (y* App::PPmm) + GadgetY(cvsDetail), (FldWidth * App::PPmm), FldHeight)
      
      SetGadgetColor(Report::FieldObject(iLoop)\TextID,#PB_Gadget_FrontColor,Report::SectionColour)     
      SetGadgetColor(Report::FieldObject(iLoop)\TextID,#PB_Gadget_BackColor ,App::#ColWhite)     
      SetGadgetFont(Report::FieldObject(iLoop)\TextID, FontID(Report::SectionHeaderFontID))
      SetGadgetText(Report::FieldObject(iLoop)\TextID, Report::FieldObject(iLoop)\Text)
      ResizeGadget(Report::FieldObject(iLoop)\TextID, (x* App::PPmm) + cvsOffset, (y* App::PPmm) + GadgetY(cvsPageHeader),(SecWidth * App::PPmm), SecHeight)

    EndIf
  Next iLoop  
    
    
EndProcedure

Procedure ShowAdorners(Show.i)
  
     HideGadget(Adorner1, Show)
     HideGadget(Adorner2, Show)
     HideGadget(Adorner3, Show)
     HideGadget(Adorner4, Show)
     
 EndProcedure

Procedure DrawAdorners(ActiveGadget)

 ; ShowAdorners(0)
;  Define x.i,y.i,Width.i,Height.i
  
;  x = GadgetX(Report::HeaderObject(ActiveGadget)\ID)
;  y =  GadgetY(Report::HeaderObject(ActiveGadget)\ID)
 ; Width =  GadgetWidth(Report::HeaderObject(ActiveGadget)\ID)
 ; Height =  GadgetHeight(Report::HeaderObject(ActiveGadget)\ID)

 ; ResizeGadget(Adorner1, x-5, y-5, 10, 10)
;  ResizeGadget(Adorner2, x+width-5, y-5, 10, 10)
;  ResizeGadget(Adorner3, x-5, y+height-5, 10, 10)
;  ResizeGadget(Adorner4, x+width-5, y+height-5, 10, 10)
   
EndProcedure

Procedure Event_Handler(Event)
  
  ;Main window event handler procedure
  
  Define StartPos.i,x.i,y.i,iLoop.i
  
  Select Event
      
    Case #PB_Event_CloseWindow
      
      End
      
    Case #PB_Event_Menu
      
      Select EventMenu()
  
        Case #mnuReportNew
          
          DrawHeader()
          ;Dim Report::HeaderObject(0)
          Dim Report::FieldObject(0) 
          Report::New()       ;Load Default Report
          ShowReportDetail()
          DrawRuler()
          DrawFieldObjects()
          DrawHeader()
      
        Case #mnuReportLoad
          
          Define Pattern.s
          Define ReportFileName.s
  
          Pattern = "Reports (*.rpt)|*.rpt;|All files (*.*)|*.*"
          ReportFileName = OpenFileRequester("Please Choose Report", GetCurrentDirectory(), Pattern, 0)
          If ReportFileName > ""
            
            FreeFieldObjects()
            Dim Report::HeaderObject(0)
            Dim Report::FieldObject(0) 
            Report::Load(ReportFileName)
            ActiveGadget = -1
            ShowAdorners(1)

          EndIf
          ShowReportDetail()
          DrawRuler()
          DrawFieldObjects()
          DrawHeader()
          
        Case #mnuReportSave 
          
          Report::Save()
          
        Case #mnuReportOptions

          Options::Open()
          ;Message loop stalled until option window is closed
          If Options::OkPressed = #True
            FreeFieldObjects()
            ShowReportDetail()
            DrawRuler()
            DrawHeader()
            DrawFieldObjects()
          EndIf
          
        Case #mnuReportPreview
          
          CDPrint::Preview.i = 1 ; Set to preview report
          Report::PrintReport()
          CDPrint::ShowPage(0)
          
        Case #mnuReportPrint
          
          CDPrint::Preview.i = 0 ; Set to print report
          Report::PrintReport()
          
        Case #mnuHdrInsTxt

          ;Set the selected text object values into dialog
          TextProperties::RText = "New Header Text"
          TextProperties::Rx = 10
          TextProperties::Ry = 10
          TextProperties::RFontName = "Arial"
          TextProperties::RFontSize = 22
          TextProperties::RFontColour = 0
          TextProperties::RFontStyle = 0     
          TextProperties::RFontID = LoadFont(#PB_Any, "Arial", 22)
          TextProperties::Open()
          If TextProperties::OkPressed = #True
            AddElement(Report::NewHeaderObject())
            Report::NewHeaderObject()\Type   = "Text"
            Report::NewHeaderObject()\Text = TextProperties::RText
            Report::NewHeaderObject()\x = TextProperties::Rx
            Report::NewHeaderObject()\y  = TextProperties::Ry
            Report::NewHeaderObject()\FontName = TextProperties::RFontName
            Report::NewHeaderObject()\FontSize = TextProperties::RFontSize
            Report::NewHeaderObject()\Colour = TextProperties::RFontColour
            Report::NewHeaderObject()\FontStyle = TextProperties::RFontStyle 
            Report::NewHeaderObject()\ID = TextProperties::RFontID
            DrawHeader()
          EndIf
           
        Case  #mnuHdrInsImg

          ImageProperties::Rtext = "" 
          ImageProperties::Ry = 5      
          ImageProperties::Rx = 5    
          ImageProperties::RMaxWidth = 25  
          ImageProperties::RMaxHeight = 25    
          ImageProperties::Open()
          If ImageProperties::OkPressed = #True
            AddElement(Report::NewHeaderObject())
            Report::NewHeaderObject()\Type   = "Image"
            Report::NewHeaderObject()\Text = ImageProperties::Rtext           ;Image Filename
            Report::NewHeaderObject()\y = ImageProperties::Ry                 ;Y Position in mm      
            Report::NewHeaderObject()\x = ImageProperties::Rx                 ;X position in mm
            Report::NewHeaderObject()\MaxWidth = ImageProperties::RMaxWidth   ;Maximum Display Width
            Report::NewHeaderObject()\MaxHeight = ImageProperties::RMaxHeight
            Report::RedoImage() 
            DrawHeader()
          EndIf     
          
        Case #mnuHdrDel
          
          ;ToDo
          
        Case #mnuExit
          
          End
          
      EndSelect  ;EventMenu()
 
    Case #PB_Event_Gadget
      
      Select EventGadget()
          
        Case ScrollArea_0

          If GetGadgetAttribute(ScrollArea_0, #PB_ScrollArea_X ) > 0
            StartPos = Int(Report::PageWidth  - (Report::PageWidth  * (CanvasWidth - GetGadgetAttribute(ScrollArea_0, #PB_ScrollArea_X )) / CanvasWidth))
          Else
            StartPos = 0
          EndIf
          
        Case cvsReportHeader
          
          Select EventType()
              
            Case #PB_EventType_RightClick
              x = GetGadgetAttribute(cvsReportHeader, #PB_Canvas_MouseX)/App::PPmm
              y = GetGadgetAttribute(cvsReportHeader, #PB_Canvas_MouseY)/App::PPmm
              If HeaderHitTest(x,y)
                
                Select Report::NewHeaderObject()\Type
                    
                  Case "Text"
                    ;Set the selected text object values into dialog
                    TextProperties::RText = Report::NewHeaderObject()\Text
                    TextProperties::Rx = Report::NewHeaderObject()\x
                    TextProperties::Ry = Report::NewHeaderObject()\y 
                    TextProperties::RFontName = Report::NewHeaderObject()\FontName
                    TextProperties::RFontSize = Report::NewHeaderObject()\FontSize
                    TextProperties::RFontColour = Report::NewHeaderObject()\Colour
                    TextProperties::RFontStyle = Report::NewHeaderObject()\FontStyle      
                    TextProperties::RFontID = Report::NewHeaderObject()\ID 
                    TextProperties::Open()
                    If TextProperties::OkPressed = #True
                      Report::NewHeaderObject()\Text = TextProperties::RText
                      Report::NewHeaderObject()\x = TextProperties::Rx
                      Report::NewHeaderObject()\y  = TextProperties::Ry
                      Report::NewHeaderObject()\FontName = TextProperties::RFontName
                      Report::NewHeaderObject()\FontSize = TextProperties::RFontSize
                      Report::NewHeaderObject()\Colour = TextProperties::RFontColour
                      Report::NewHeaderObject()\FontStyle = TextProperties::RFontStyle 
                      Report::NewHeaderObject()\ID = TextProperties::RFontID
                      DrawHeader()
                    EndIf
                    
                  Case "Image"
                    
                    ImageProperties::Rtext = Report::NewHeaderObject()\Text             ;Image Filename
                    ImageProperties::Ry = Report::NewHeaderObject()\y                   ;Y Position in mm      
                    ImageProperties::Rx = Report::NewHeaderObject()\x                   ;X position in mm
                    ImageProperties::RMaxWidth = Report::NewHeaderObject()\MaxWidth     ;Maximum Display Width
                    ImageProperties::RMaxHeight = Report::NewHeaderObject()\MaxHeight   ;Maximum Display Width   
                    ImageProperties::Open()
                    If ImageProperties::OkPressed = #True
                      Report::NewHeaderObject()\Text = ImageProperties::Rtext           ;Image Filename
                      Report::NewHeaderObject()\y = ImageProperties::Ry                 ;Y Position in mm      
                      Report::NewHeaderObject()\x = ImageProperties::Rx                 ;X position in mm
                      Report::NewHeaderObject()\MaxWidth = ImageProperties::RMaxWidth   ;Maximum Display Width
                      Report::NewHeaderObject()\MaxHeight = ImageProperties::RMaxHeight
                      Report::RedoImage() 
                      DrawHeader()
                    EndIf
                  
                EndSelect
                               
              EndIf
                           
            Case #PB_EventType_LeftButtonDown
              x = GetGadgetAttribute(cvsReportHeader, #PB_Canvas_MouseX)/App::PPmm
              y = GetGadgetAttribute(cvsReportHeader, #PB_Canvas_MouseY)/App::PPmm
              If HeaderHitTest(x,y)
                DrawHeader()
              EndIf
              Drag = #True
              
            Case #PB_EventType_LeftButtonUp
              Drag = #False
              
            Case #PB_EventType_MouseMove
              If Drag = #True
                If isCurrentItem
                  x = GetGadgetAttribute(cvsReportHeader, #PB_Canvas_MouseX)/App::PPmm
                  y = GetGadgetAttribute(cvsReportHeader, #PB_Canvas_MouseY)/App::PPmm
                  If LastElement(Report::NewHeaderObject())
                      Report::NewHeaderObject()\x = x - currentItemXOffset
                      Report::NewHeaderObject()\y = y - currentItemYOffset
                      DrawHeader()
                  EndIf
                EndIf
              EndIf
          EndSelect
          
        Case  btnPageHeader
          If FontRequester(Report::SectionFontName, Report::SectionFontSize, #PB_FontRequester_Effects,Report::SectionColour,Report::SectionFontStyle) > 0
            If LoadFont(1, SelectedFontName(), SelectedFontSize(),SelectedFontStyle())
              Report::SectionFontName = SelectedFontName()
              Report::SectionFontSize = SelectedFontSize()
              Report::SectionColour = SelectedFontColor()
              Report::SectionFontStyle = SelectedFontStyle()
              Report::SectionHeaderFontID = LoadFont(#PB_Any, Report::SectionFontName, Report::SectionFontSize,Report::SectionFontStyle)
            EndIf
          EndIf
          FreeFieldObjects()
          DrawFieldObjects()
          
        Case btnDetail
          
          If FontRequester(Report::FieldFontName, Report::FieldFontSize, #PB_FontRequester_Effects,Report::FieldColour,Report::FieldFontStyle) > 0
            If LoadFont(1, SelectedFontName(), SelectedFontSize(),SelectedFontStyle())
              Report::FieldFontName = SelectedFontName()
              Report::FieldFontSize = SelectedFontSize()
              Report::FieldColour = SelectedFontColor()
              Report::FieldFontStyle = SelectedFontStyle()
              Report::FieldFontID =  LoadFont(#PB_Any, Report::FieldFontName, Report::FieldFontSize,Report::FieldFontStyle)
            EndIf
            FreeFieldObjects() 
            DrawFieldObjects()     
          EndIf
      EndSelect ;EventGadget()
      
  EndSelect ;Event
  
EndProcedure

  frmMain = OpenWindow(#PB_Any, 0, 0,950, 385, "Report Designer", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CreateMenu(0, WindowID(frmMain))
  CreateMenu(0, WindowID(frmMain))
  MenuTitle("Report")
  MenuItem(#mnuReportNew, "New")
  MenuItem(#mnuReportLoad, "Load")
  MenuItem(#mnuReportSave, "Save")
  MenuBar()
  OpenSubMenu("Header")
  OpenSubMenu("Insert")
  MenuItem(#mnuHdrInsTxt, "Text")
  MenuItem(#mnuHdrInsImg, "Image")
  CloseSubMenu()
  MenuItem(#mnuHdrDel, "Delete Item")
  CloseSubMenu()
  MenuBar()
  MenuItem(#mnuReportOptions, "Options") 
  MenuItem(#mnuReportPreview, "Preview")
  MenuItem(#mnuReportPrint, "Print")  
  MenuBar()
  MenuItem(#mnuExit, "Exit")  
  
  ;Get screen Pixels Per mm
  StartVectorDrawing(WindowVectorOutput(frmMain))
  App::PPmm = VectorResolutionX()/25.4
  StopVectorDrawing()

  ScrollArea_0 = ScrollAreaGadget(#PB_Any, 10, 0, 780, 350, 854, 330, App::PPmm,#PB_ScrollArea_BorderLess)  
  SetGadgetColor(ScrollArea_0, #PB_Gadget_BackColor,RGB(192,192,192))
  cvsRuler = CanvasGadget(#PB_Any, 0, 0, 845, 20)
  btnReportHeader = ButtonGadget(#PB_Any, 0, 20, 845, 20, "Report Header")
  cvsReportHeader = CanvasGadget(#PB_Any, 0, 40, 845, 190)
  GadgetToolTip(cvsReportHeader, "Report Header printed once on page one")
  btnPageHeader = ButtonGadget(#PB_Any, 0, 230, 570, 20, "Section Header")  
  cvsPageHeader = CanvasGadget(#PB_Any, 0, 250, 400, 30)
  GadgetToolTip(cvsPageHeader, "Section Header printed at start of each new page Or Section")
  btnDetail = ButtonGadget(#PB_Any, 0, 280, 570, 20, "Detail")  
  cvsDetail = CanvasGadget(#PB_Any, 0, 300, 400, 30)
  GadgetToolTip(cvsDetail, "Detail Section")
  Adorner1 = TextGadget(#PB_Any, 90, 70, 10, 10,"") 
  SetGadgetColor(Adorner1, #PB_Gadget_BackColor,RGB(0,255,64))
  Adorner2 = TextGadget(#PB_Any, 110, 90, 10, 10,"")
  SetGadgetColor(Adorner2, #PB_Gadget_BackColor,RGB(0,255,64))
  Adorner3 = TextGadget(#PB_Any, 130, 110, 10, 10,"")
  SetGadgetColor(Adorner3, #PB_Gadget_BackColor,RGB(0,255,64))
  Adorner4 = TextGadget(#PB_Any, 150, 130, 10, 10,"")
  SetGadgetColor(Adorner4, #PB_Gadget_BackColor,RGB(0,255,64)) 
  CloseGadgetList()
  txtPageDetail = TextGadget(#PB_Any, 800, 10, 130, 20, "Page Detail")
  TextGadget(#PB_Any, 800, 45, 130, 20, "Width")
  strPageWidth = StringGadget(#PB_Any, 875, 40, 40, 20, "") 
  TextGadget(#PB_Any, 800, 70, 130, 20, "Height")
  strPageHeight = StringGadget(#PB_Any, 875, 65, 40, 20, "")  
  TextGadget(#PB_Any, 800, 95, 130, 20, "Top Margin")
  strTopMargin = StringGadget(#PB_Any, 875, 90, 40, 20, "")    
  TextGadget(#PB_Any, 800, 120, 130, 20, "Left Margin")
  strLeftMargin = StringGadget(#PB_Any, 875, 115, 40, 20, "")   
  TextGadget(#PB_Any, 800, 145, 155, 20, "Bottom Margin")
  strBottomMargin = StringGadget(#PB_Any, 875, 140, 40, 20, "")    
  TextGadget(#PB_Any, 800, 170, 180, 20, "Right Margin")
  strRightMargin = StringGadget(#PB_Any, 875, 165, 40, 20, "")   
  
  ;Set Delete key for deleting header objects
  AddKeyboardShortcut(frmMain,#PB_Shortcut_Delete,#mnuHdrDel)

  ;Load report defaults
  Report::New()
  
  ;Show current default report
  DrawRuler()
  
  ;Ensure adorners are hidden
  ShowAdorners(1)
  
  If ProgramParameter(0) > ""
    Report::DBName = ProgramParameter(0)
  EndIf
    
  Repeat
    Event = WaitWindowEvent()
    
    If IsWindow(EventWindow())
      Select EventWindow()
          
        Case frmMain
          
          Event_Handler(Event)
          
        Case CDPrint::PreviewWindow
          CDPrint::CDPrintEvents(Event)
      EndSelect
      
    EndIf
    
  ForEver
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 150
; FirstLine = 106
; Folding = nA-
; EnableUnicode
; EnableXP